#include "drally_fonts.h"

const font_props_t ___185ba9h = {
    .w = 0x20,
    .h = 0x20,
    .props = {
        0x14, 0x09, 0x0e, 0x14, 0x15, 0x18, 0x15, 0x0a, 0x0c, 0x0b, 0x10, 0x15, 0x09, 0x14, 0x08,0x13,
        0x15, 0x0a, 0x14, 0x13, 0x14, 0x14, 0x13, 0x12, 0x13, 0x12, 0x08, 0x09, 0x10, 0x15, 0x10, 0x0f,
        0x16, 0x16, 0x15, 0x14, 0x16, 0x13, 0x12, 0x16, 0x16, 0x0a, 0x11, 0x15, 0x13, 0x1b, 0x15, 0x16,
        0x14, 0x16, 0x15, 0x14, 0x14, 0x16, 0x18, 0x1f, 0x16, 0x17, 0x13, 0x0c, 0x14, 0x0c, 0x14, 0x13,
        0x09, 0x14, 0x12, 0x11, 0x12, 0x10, 0x0f, 0x13, 0x12, 0x08, 0x0e, 0x13, 0x10, 0x16, 0x12, 0x12,
        0x10, 0x12, 0x12, 0x11, 0x10, 0x12, 0x13, 0x1a, 0x12, 0x13, 0x10, 0x0b, 0x06, 0x0b, 0x0f, 0x14
    }
};

const font_props_t ___185c0bh = {
    .w = 0x10,
    .h = 0x10,
    .props = {
        0x0a, 0x05, 0x08, 0x0b, 0x0b, 0x0d, 0x0b, 0x05, 0x06, 0x06, 0x09, 0x0b, 0x05, 0x0b, 0x04, 0x0a,
        0x0b, 0x05, 0x09, 0x0a, 0x0a, 0x0a, 0x0a, 0x0a, 0x0a, 0x0a, 0x04, 0x05, 0x09, 0x0b, 0x08, 0x08,
        0x0c, 0x0b, 0x0b, 0x0a, 0x0b, 0x0a, 0x0a, 0x0c, 0x0b, 0x05, 0x09, 0x0b, 0x0a, 0x0e, 0x0b, 0x0b,
        0x0a, 0x0b, 0x0b, 0x0a, 0x0a, 0x0b, 0x0c, 0x0f, 0x0b, 0x0b, 0x0a, 0x07, 0x0a, 0x06, 0x0a, 0x0a,
        0x05, 0x0b, 0x0a, 0x09, 0x0a, 0x09, 0x09, 0x0a, 0x0a, 0x05, 0x08, 0x0a, 0x09, 0x0c, 0x0a, 0x0a,
        0x09, 0x0a, 0x0a, 0x09, 0x09, 0x0a, 0x0a, 0x0e, 0x0a, 0x0a, 0x09, 0x07, 0x04, 0x07, 0x09, 0x0b
    }
};

const font_props_t ___185c6dh = {
    .w = 0x10,
    .h = 0x0d,
    .props = {
        0x0e /*'$'*/,
        0x0d /*'0'*/, 0x09 /*'1'*/, 0x0d /*'2'*/, 0x0d /*'3'*/, 0x0d /*'4'*/,
        0x0d /*'5'*/, 0x0d /*'6'*/, 0x0c /*'7'*/, 0x0d /*'8'*/, 0x0d /*'9'*/   
    }
};

const font_props_t ___185c7ah = {
    .w = 0x09,
    .h = 0x0c,
    .props = {
        9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
        9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
        9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
        9,9,9,9,9,9,9,9,9,9,9,9,9,9,0,0 
    }
};


static int helper_width(const char * s, const font_props_t * fp){

	int 	n, offset;

	offset = 0;
	n = -1;
	while(s[++n]) offset += fp->props[s[n]-0x20];

	return offset;
}

static int c_index(int c){ return ((c &= 0xff) == '$') ? 0 : c-0x2f; }
static unsigned char c_width(int c){ return ___185c6dh.props[c_index(c)]; }
static int helper_width_2(const char * s){

	int 	n, offset;

	offset = 0;
	n = -1;
	while(s[++n]) offset += c_width(s[n]);

	return offset;
}

int getTextWidth(int props, const char * s){

    int rslt;

    switch(props){
    case FONTPROPS01:
        rslt = helper_width(s, &___185ba9h);
        break;
    case FONTPROPS02:
        rslt = helper_width(s, &___185c0bh);
        break;
    case FONTPROPS03:
        rslt = helper_width(s, &___185c7ah);
        break;
    case FONTPROPS04:
        rslt = helper_width_2(s);
        break;
    default:
        printf("[dRally.Fonts] Unknown font proportions 0x%02X\n", props);
        rslt = 0;
        break;
    }

    return rslt;
}
